OGRE: Ogre::MeshManager Class Reference - OGRE Documentation

# Ogre::MeshManager Class Reference

Handles the management of mesh resources. More...

`#include <OgreMeshManager.h>`

Inheritance diagram for Ogre::MeshManager:

[legend]

List of all members.

## Public Types
typedef std::pair< ResourcePtr, bool > | ResourceCreateOrRetrieveResult
typedef HashMap< String, ResourcePtr > | ResourceMap
typedef std::map < ResourceHandle, ResourcePtr > | ResourceHandleMap
typedef MapIterator < ResourceHandleMap > | ResourceMapIterator
## Public Member Functions
| MeshManager ()
| ~MeshManager ()
void | _initialise (void)
| Initialises the manager, only to be called by OGRE internally.
ResourceCreateOrRetrieveResult | createOrRetrieve (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *params=0, HardwareBuffer::Usage vertexBufferUsage=HardwareBuffer::HBU_STATIC_WRITE_ONLY, HardwareBuffer::Usage indexBufferUsage=HardwareBuffer::HBU_STATIC_WRITE_ONLY, bool vertexBufferShadowed=true, bool indexBufferShadowed=true)
| Create a new mesh, or retrieve an existing one with the same name if it already exists.
MeshPtr | prepare (const String &filename, const String &groupName, HardwareBuffer::Usage vertexBufferUsage=HardwareBuffer::HBU_STATIC_WRITE_ONLY, HardwareBuffer::Usage indexBufferUsage=HardwareBuffer::HBU_STATIC_WRITE_ONLY, bool vertexBufferShadowed=true, bool indexBufferShadowed=true)
| Prepares a mesh for loading from a file.
MeshPtr | load (const String &filename, const String &groupName, HardwareBuffer::Usage vertexBufferUsage=HardwareBuffer::HBU_STATIC_WRITE_ONLY, HardwareBuffer::Usage indexBufferUsage=HardwareBuffer::HBU_STATIC_WRITE_ONLY, bool vertexBufferShadowed=true, bool indexBufferShadowed=true)
| Loads a mesh from a file, making it immediately available for use.
MeshPtr | createManual (const String &name, const String &groupName, ManualResourceLoader *loader=0)
| Creates a new Mesh specifically for manual definition rather than loading from an object file.
MeshPtr | createPlane (const String &name, const String &groupName, const Plane &plane, Real width, Real height, int xsegments=1, int ysegments=1, bool normals=true, int numTexCoordSets=1, Real uTile=1.0f, Real vTile=1.0f, const Vector3 &upVector=Vector3::UNIT_Y, HardwareBuffer::Usage vertexBufferUsage=HardwareBuffer::HBU_STATIC_WRITE_ONLY, HardwareBuffer::Usage indexBufferUsage=HardwareBuffer::HBU_STATIC_WRITE_ONLY, bool vertexShadowBuffer=true, bool indexShadowBuffer=true)
| Creates a basic plane, by default majoring on the x/y axes facing positive Z.
MeshPtr | createCurvedIllusionPlane (const String &name, const String &groupName, const Plane &plane, Real width, Real height, Real curvature, int xsegments=1, int ysegments=1, bool normals=true, int numTexCoordSets=1, Real uTile=1.0f, Real vTile=1.0f, const Vector3 &upVector=Vector3::UNIT_Y, const Quaternion &orientation=Quaternion::IDENTITY, HardwareBuffer::Usage vertexBufferUsage=HardwareBuffer::HBU_STATIC_WRITE_ONLY, HardwareBuffer::Usage indexBufferUsage=HardwareBuffer::HBU_STATIC_WRITE_ONLY, bool vertexShadowBuffer=true, bool indexShadowBuffer=true, int ySegmentsToKeep=-1)
| Creates a plane, which because of it's texture coordinates looks like a curved surface, useful for skies in a skybox.
MeshPtr | createCurvedPlane (const String &name, const String &groupName, const Plane &plane, Real width, Real height, Real bow=0.5f, int xsegments=1, int ysegments=1, bool normals=false, int numTexCoordSets=1, Real xTile=1.0f, Real yTile=1.0f, const Vector3 &upVector=Vector3::UNIT_Y, HardwareBuffer::Usage vertexBufferUsage=HardwareBuffer::HBU_STATIC_WRITE_ONLY, HardwareBuffer::Usage indexBufferUsage=HardwareBuffer::HBU_STATIC_WRITE_ONLY, bool vertexShadowBuffer=true, bool indexShadowBuffer=true)
| Creates a genuinely curved plane, by default majoring on the x/y axes facing positive Z.
PatchMeshPtr | createBezierPatch (const String &name, const String &groupName, void *controlPointBuffer, VertexDeclaration *declaration, size_t width, size_t height, size_t uMaxSubdivisionLevel=PatchSurface::AUTO_LEVEL, size_t vMaxSubdivisionLevel=PatchSurface::AUTO_LEVEL, PatchSurface::VisibleSide visibleSide=PatchSurface::VS_FRONT, HardwareBuffer::Usage vbUsage=HardwareBuffer::HBU_STATIC_WRITE_ONLY, HardwareBuffer::Usage ibUsage=HardwareBuffer::HBU_DYNAMIC_WRITE_ONLY, bool vbUseShadow=true, bool ibUseShadow=true)
| Creates a Bezier patch based on an array of control vertices.
void | setPrepareAllMeshesForShadowVolumes (bool enable)
| Tells the mesh manager that all future meshes should prepare themselves for shadow volumes on loading.
bool | getPrepareAllMeshesForShadowVolumes (void)
| Retrieves whether all Meshes should prepare themselves for shadow volumes.
Real | getBoundsPaddingFactor (void)
| Gets the factor by which the bounding box of an entity is padded.
void | setBoundsPaddingFactor (Real paddingFactor)
| Sets the factor by which the bounding box of an entity is padded.
void | setListener (MeshSerializerListener *listener)
| Sets the listener used to control mesh loading through the serializer.
MeshSerializerListener * | getListener ()
| Gets the listener used to control mesh loading through the serializer.
void | loadResource (Resource *res)
virtual ResourcePtr | create (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Creates a new blank resource, but does not immediately load it.
virtual ResourceCreateOrRetrieveResult | createOrRetrieve (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Create a new resource, or retrieve an existing one with the same name if it already exists.
virtual void | setMemoryBudget (size_t bytes)
| Set a limit on the amount of memory this resource handler may use.
virtual size_t | getMemoryBudget (void) const
| Get the limit on the amount of memory this resource handler may use.
virtual size_t | getMemoryUsage (void) const
| Gets the current memory usage, in bytes.
virtual void | unload (const String &name)
| Unloads a single resource by name.
virtual void | unload (ResourceHandle handle)
| Unloads a single resource by handle.
virtual void | unloadAll (bool reloadableOnly=true)
| Unloads all resources.
virtual void | reloadAll (bool reloadableOnly=true)
| Caused all currently loaded resources to be reloaded.
virtual void | unloadUnreferencedResources (bool reloadableOnly=true)
| Unload all resources which are not referenced by any other object.
virtual void | reloadUnreferencedResources (bool reloadableOnly=true)
| Caused all currently loaded but not referenced by any other object resources to be reloaded.
virtual void | remove (ResourcePtr &r)
| Remove a single resource.
virtual void | remove (const String &name)
| Remove a single resource by name.
virtual void | remove (ResourceHandle handle)
| Remove a single resource by handle.
virtual void | removeAll (void)
| Removes all resources.
virtual ResourcePtr | getByName (const String &name)
| Retrieves a pointer to a resource by name, or null if the resource does not exist.
virtual ResourcePtr | getByHandle (ResourceHandle handle)
| Retrieves a pointer to a resource by handle, or null if the resource does not exist.
virtual bool | resourceExists (const String &name)
| Returns whether the named resource exists in this manager.
virtual bool | resourceExists (ResourceHandle handle)
| Returns whether a resource with the given handle exists in this manager.
virtual void | _notifyResourceTouched (Resource *res)
| Notify this manager that a resource which it manages has been 'touched', i.e.
virtual void | _notifyResourceLoaded (Resource *res)
| Notify this manager that a resource which it manages has been loaded.
virtual void | _notifyResourceUnloaded (Resource *res)
| Notify this manager that a resource which it manages has been unloaded.
virtual ResourcePtr | prepare (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *loadParams=0)
| Generic prepare method, used to create a Resource specific to this ResourceManager without using one of the specialised 'prepare' methods (containing per-Resource-type parameters).
virtual ResourcePtr | load (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *loadParams=0)
| Generic load method, used to create a Resource specific to this ResourceManager without using one of the specialised 'load' methods (containing per-Resource-type parameters).
virtual const StringVector & | getScriptPatterns (void) const
| Gets the file patterns which should be used to find scripts for this ResourceManager.
virtual void | parseScript (DataStreamPtr &stream, const String &groupName)
| Parse the definition of a set of resources from a script file.
virtual Real | getLoadingOrder (void) const
| Gets the relative loading order of resources of this type.
const String & | getResourceType (void) const
| Gets a string identifying the type of resource this manager handles.
virtual void | setVerbose (bool v)
| Sets whether this manager and its resources habitually produce log output.
virtual bool | getVerbose (void)
| Gets whether this manager and its resources habitually produce log output.
ResourceMapIterator | getResourceIterator (void)
| Returns an iterator over all resources in this manager.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
virtual void | prepareResource (Resource *resource)
| Called when a resource wishes to load.
## Static Public Member Functions
static MeshManager & | getSingleton (void)
| Override standard Singleton retrieval.
static MeshManager * | getSingletonPtr (void)
| Override standard Singleton retrieval.
## Protected Types
enum | MeshBuildType { MBT_PLANE, MBT_CURVED_ILLUSION_PLANE, MBT_CURVED_PLANE }
| Enum identifying the types of manual mesh built by this manager. More...
typedef std::map< Resource *, MeshBuildParams > | MeshBuildParamsMap
| Map from resource pointer to parameter set.
## Protected Member Functions
Resource * | createImpl (const String &name, ResourceHandle handle, const String &group, bool isManual, ManualResourceLoader *loader, const NameValuePairList *createParams)
  | Create a new resource instance compatible with this manager (no custom parameters are populated at this point). Remarks: Subclasses must override this method and create a subclass of Resource. Parameters:
  | name | The unique name of the resource
  | group | The name of the resource group to attach this new resource to
  | isManual | Is this resource manually loaded? If so, you should really populate the loader parameter in order that the load process can call the loader back when loading is required.
  | loader | Pointer to a ManualLoader implementation which will be called when the Resource wishes to load (should be supplied if you set isManual to true). You can in fact leave this parameter null if you wish, but the Resource will never be able to reload if anything ever causes it to unload. Therefore provision of a proper ManualLoader instance is strongly recommended.
  | createParams | If any parameters are required to create an instance, they should be supplied here as name / value pairs. These do not need to be set on the instance (handled elsewhere), just used if required to differentiate which concrete class is created.
void | tesselate2DMesh (SubMesh *pSub, int meshWidth, int meshHeight, bool doubleSided=false, HardwareBuffer::Usage indexBufferUsage=HardwareBuffer::HBU_STATIC_WRITE_ONLY, bool indexSysMem=false)
| Utility method for tessellating 2D meshes.
void | createPrefabPlane (void)
void | createPrefabCube (void)
void | createPrefabSphere (void)
void | loadManualPlane (Mesh *pMesh, MeshBuildParams &params)
| Utility method for manual loading a plane.
void | loadManualCurvedPlane (Mesh *pMesh, MeshBuildParams &params)
| Utility method for manual loading a curved plane.
void | loadManualCurvedIllusionPlane (Mesh *pMesh, MeshBuildParams &params)
| Utility method for manual loading a curved illusion plane.
ResourceHandle | getNextHandle (void)
| Allocates the next handle.
virtual void | addImpl (ResourcePtr &res)
| Add a newly created resource to the manager (note weak reference).
virtual void | removeImpl (ResourcePtr &res)
| Remove a resource from this manager; remove it from the lists.
virtual void | checkUsage (void)
| Checks memory usage and pages out if required.
## Protected Attributes
MeshBuildParamsMap | mMeshBuildParams
bool | mPrepAllMeshesForShadowVolumes
Real | mBoundsPaddingFactor
MeshSerializerListener * | mListener
ResourceHandleMap | mResourcesByHandle
ResourceMap | mResources
ResourceHandle | mNextHandle
size_t | mMemoryBudget
size_t | mMemoryUsage
bool | mVerbose
StringVector | mScriptPatterns
| Patterns to use to look for scripts if supported (e.g. *.overlay).
Real | mLoadOrder
| Loading order relative to other managers, higher is later.
String | mResourceType
| String identifying the resource type this manager handles.
## Static Protected Attributes
static T * | ms_Singleton
## Classes
struct | MeshBuildParams
| Saved parameters used to (re)build a manual mesh built by this class. More...

## Detailed Description

Handles the management of mesh resources.

Remarks:
  This class deals with the runtime management of mesh data; like other resource managers it handles the creation of resources (in this case mesh data), working within a fixed memory budget.

Definition at line 52 of file OgreMeshManager.h.

## Member Typedef Documentation

typedef std::map<Resource*, MeshBuildParams> Ogre::MeshManager::MeshBuildParamsMap`[protected]`

Map from resource pointer to parameter set.

Definition at line 468 of file OgreMeshManager.h.

typedef std::pair<ResourcePtr, bool> Ogre::ResourceManager::ResourceCreateOrRetrieveResult`[inherited]`

Definition at line 98 of file OgreResourceManager.h.

typedef HashMap< String, ResourcePtr > Ogre::ResourceManager::ResourceMap`[inherited]`

Definition at line 434 of file OgreResourceManager.h.

typedef std::map<ResourceHandle, ResourcePtr> Ogre::ResourceManager::ResourceHandleMap`[inherited]`

Definition at line 435 of file OgreResourceManager.h.

typedef MapIterator<ResourceHandleMap> Ogre::ResourceManager::ResourceMapIterator`[inherited]`

Definition at line 455 of file OgreResourceManager.h.

## Member Enumeration Documentation

enum Ogre::MeshManager::MeshBuildType`[protected]`

Enum identifying the types of manual mesh built by this manager.

Enumerator:

  MBT_PLANE |
  MBT_CURVED_ILLUSION_PLANE |
  MBT_CURVED_PLANE |

Definition at line 439 of file OgreMeshManager.h.

## Constructor & Destructor Documentation

Ogre::MeshManager::MeshManager | ( |  | ) |

Ogre::MeshManager::~MeshManager | ( |  | ) |

## Member Function Documentation

void Ogre::MeshManager::_initialise | ( | void |  | ) |

Initialises the manager, only to be called by OGRE internally.

ResourceCreateOrRetrieveResult Ogre::MeshManager::createOrRetrieve | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0`,
|  | const NameValuePairList * | params = `0`,
|  | HardwareBuffer::Usage | vertexBufferUsage = `HardwareBuffer::HBU_STATIC_WRITE_ONLY`,
|  | HardwareBuffer::Usage | indexBufferUsage = `HardwareBuffer::HBU_STATIC_WRITE_ONLY`,
|  | bool | vertexBufferShadowed = `true`,
|  | bool | indexBufferShadowed = `true` |
| ) |  |  |

Create a new mesh, or retrieve an existing one with the same name if it already exists.

Parameters:

  | vertexBufferUsage | The usage flags with which the vertex buffer(s) will be created
  | indexBufferUsage | The usage flags with which the index buffer(s) created for this mesh will be created with.
  | vertexBufferShadowed | If true, the vertex buffers will be shadowed by system memory copies for faster read access
  | indexBufferShadowed | If true, the index buffers will be shadowed by system memory copies for faster read access

See also:
  ResourceManager::createOrRetrieve

MeshPtr Ogre::MeshManager::prepare | ( | const String & | filename,
|  | const String & | groupName,
|  | HardwareBuffer::Usage | vertexBufferUsage = `HardwareBuffer::HBU_STATIC_WRITE_ONLY`,
|  | HardwareBuffer::Usage | indexBufferUsage = `HardwareBuffer::HBU_STATIC_WRITE_ONLY`,
|  | bool | vertexBufferShadowed = `true`,
|  | bool | indexBufferShadowed = `true` |
| ) |  |  |

Prepares a mesh for loading from a file.

This does the IO in advance of the call to load().

Note:
  If the model has already been created (prepared or loaded), the existing instance will be returned.

Remarks:
  Ogre loads model files from it's own proprietary format called .mesh. This is because having a single file format is better for runtime performance, and we also have control over pre-processed data (such as collision boxes, LOD reductions etc).

Parameters:

  | filename | The name of the .mesh file
  | groupName | The name of the resource group to assign the mesh to
  | vertexBufferUsage | The usage flags with which the vertex buffer(s) will be created
  | indexBufferUsage | The usage flags with which the index buffer(s) created for this mesh will be created with.
  | vertexBufferShadowed | If true, the vertex buffers will be shadowed by system memory copies for faster read access
  | indexBufferShadowed | If true, the index buffers will be shadowed by system memory copies for faster read access

MeshPtr Ogre::MeshManager::load | ( | const String & | filename,
|  | const String & | groupName,
|  | HardwareBuffer::Usage | vertexBufferUsage = `HardwareBuffer::HBU_STATIC_WRITE_ONLY`,
|  | HardwareBuffer::Usage | indexBufferUsage = `HardwareBuffer::HBU_STATIC_WRITE_ONLY`,
|  | bool | vertexBufferShadowed = `true`,
|  | bool | indexBufferShadowed = `true` |
| ) |  |  |

Loads a mesh from a file, making it immediately available for use.

Note:
  If the model has already been created (prepared or loaded), the existing instance will be returned.

Remarks:
  Ogre loads model files from it's own proprietary format called .mesh. This is because having a single file format is better for runtime performance, and we also have control over pre-processed data (such as collision boxes, LOD reductions etc).

Parameters:

  | filename | The name of the .mesh file
  | groupName | The name of the resource group to assign the mesh to
  | vertexBufferUsage | The usage flags with which the vertex buffer(s) will be created
  | indexBufferUsage | The usage flags with which the index buffer(s) created for this mesh will be created with.
  | vertexBufferShadowed | If true, the vertex buffers will be shadowed by system memory copies for faster read access
  | indexBufferShadowed | If true, the index buffers will be shadowed by system memory copies for faster read access

MeshPtr Ogre::MeshManager::createManual | ( | const String & | name,
|  | const String & | groupName,
|  | ManualResourceLoader * | loader = `0` |
| ) |  |  |

Creates a new Mesh specifically for manual definition rather than loading from an object file.

Remarks:
  Note that once you've defined your mesh, you must call Mesh::_setBounds and Mesh::_setBoundingRadius in order to define the bounds of your mesh. In previous versions of OGRE you could call Mesh::_updateBounds, but OGRE's support of write-only vertex buffers makes this no longer appropriate.

Parameters:

  | name | The name to give the new mesh
  | groupName | The name of the resource group to assign the mesh to
  | loader | ManualResourceLoader which will be called to load this mesh when the time comes. It is recommended that you populate this field in order that the mesh can be rebuilt should the need arise

MeshPtr Ogre::MeshManager::createPlane | ( | const String & | name,
|  | const String & | groupName,
|  | const Plane & | plane,
|  | Real | width,
|  | Real | height,
|  | int | xsegments = `1`,
|  | int | ysegments = `1`,
|  | bool | normals = `true`,
|  | int | numTexCoordSets = `1`,
|  | Real | uTile = `1.0f`,
|  | Real | vTile = `1.0f`,
|  | const Vector3 & | upVector = `Vector3::UNIT_Y`,
|  | HardwareBuffer::Usage | vertexBufferUsage = `HardwareBuffer::HBU_STATIC_WRITE_ONLY`,
|  | HardwareBuffer::Usage | indexBufferUsage = `HardwareBuffer::HBU_STATIC_WRITE_ONLY`,
|  | bool | vertexShadowBuffer = `true`,
|  | bool | indexShadowBuffer = `true` |
| ) |  |  |

Creates a basic plane, by default majoring on the x/y axes facing positive Z.

Parameters:

  | name | The name to give the resulting mesh
  | groupName | The name of the resource group to assign the mesh to
  | plane | The orientation of the plane and distance from the origin
  | width | The width of the plane in world coordinates
  | height | The height of the plane in world coordinates
  | xsegments | The number of segments to the plane in the x direction
  | ysegments | The number of segments to the plane in the y direction
  | normals | If true, normals are created perpendicular to the plane
  | numTexCoordSets | The number of 2D texture coordinate sets created - by default the corners are created to be the corner of the texture.
  | uTile | The number of times the texture should be repeated in the u direction
  | vTile | The number of times the texture should be repeated in the v direction
  | upVector | The 'Up' direction of the plane.
  | vertexBufferUsage | The usage flag with which the vertex buffer for this plane will be created
  | indexBufferUsage | The usage flag with which the index buffer for this plane will be created
  | vertexShadowBuffer | If this flag is set to true, the vertex buffer will be created with a system memory shadow buffer, allowing you to read it back more efficiently than if it is in hardware
  | indexShadowBuffer | If this flag is set to true, the index buffer will be created with a system memory shadow buffer, allowing you to read it back more efficiently than if it is in hardware

MeshPtr Ogre::MeshManager::createCurvedIllusionPlane | ( | const String & | name,
|  | const String & | groupName,
|  | const Plane & | plane,
|  | Real | width,
|  | Real | height,
|  | Real | curvature,
|  | int | xsegments = `1`,
|  | int | ysegments = `1`,
|  | bool | normals = `true`,
|  | int | numTexCoordSets = `1`,
|  | Real | uTile = `1.0f`,
|  | Real | vTile = `1.0f`,
|  | const Vector3 & | upVector = `Vector3::UNIT_Y`,
|  | const Quaternion & | orientation = `Quaternion::IDENTITY`,
|  | HardwareBuffer::Usage | vertexBufferUsage = `HardwareBuffer::HBU_STATIC_WRITE_ONLY`,
|  | HardwareBuffer::Usage | indexBufferUsage = `HardwareBuffer::HBU_STATIC_WRITE_ONLY`,
|  | bool | vertexShadowBuffer = `true`,
|  | bool | indexShadowBuffer = `true`,
|  | int | ySegmentsToKeep = `-1` |
| ) |  |  |

Creates a plane, which because of it's texture coordinates looks like a curved surface, useful for skies in a skybox.

Parameters:

  | name | The name to give the resulting mesh
  | groupName | The name of the resource group to assign the mesh to
  | plane | The orientation of the plane and distance from the origin
  | width | The width of the plane in world coordinates
  | height | The height of the plane in world coordinates
  | curvature | The curvature of the plane. Good values are between 2 and 65. Higher values are more curved leading to a smoother effect, lower values are less curved meaning more distortion at the horizons but a better distance effect.
  | xsegments | The number of segments to the plane in the x direction
  | ysegments | The number of segments to the plane in the y direction
  | normals | If true, normals are created perpendicular to the plane
  | numTexCoordSets | The number of 2D texture coordinate sets created - by default the corners are created to be the corner of the texture.
  | uTile | The number of times the texture should be repeated in the u direction
  | vTile | The number of times the texture should be repeated in the v direction
  | upVector | The 'Up' direction of the plane.
  | orientation | The orientation of the overall sphere that's used to create the illusion
  | vertexBufferUsage | The usage flag with which the vertex buffer for this plane will be created
  | indexBufferUsage | The usage flag with which the index buffer for this plane will be created
  | vertexShadowBuffer | If this flag is set to true, the vertex buffer will be created with a system memory shadow buffer, allowing you to read it back more efficiently than if it is in hardware
  | indexShadowBuffer | If this flag is set to true, the index buffer will be created with a system memory shadow buffer, allowing you to read it back more efficiently than if it is in hardware
  | ySegmentsToKeep | The number of segments from the top of the dome downwards to keep. -1 keeps all of them. This can save fillrate if you cannot see much of the sky lower down.

MeshPtr Ogre::MeshManager::createCurvedPlane | ( | const String & | name,
|  | const String & | groupName,
|  | const Plane & | plane,
|  | Real | width,
|  | Real | height,
|  | Real | bow = `0.5f`,
|  | int | xsegments = `1`,
|  | int | ysegments = `1`,
|  | bool | normals = `false`,
|  | int | numTexCoordSets = `1`,
|  | Real | xTile = `1.0f`,
|  | Real | yTile = `1.0f`,
|  | const Vector3 & | upVector = `Vector3::UNIT_Y`,
|  | HardwareBuffer::Usage | vertexBufferUsage = `HardwareBuffer::HBU_STATIC_WRITE_ONLY`,
|  | HardwareBuffer::Usage | indexBufferUsage = `HardwareBuffer::HBU_STATIC_WRITE_ONLY`,
|  | bool | vertexShadowBuffer = `true`,
|  | bool | indexShadowBuffer = `true` |
| ) |  |  |

Creates a genuinely curved plane, by default majoring on the x/y axes facing positive Z.

Parameters:

  | name | The name to give the resulting mesh
  | groupName | The name of the resource group to assign the mesh to
  | plane | The orientation of the plane and distance from the origin
  | width | The width of the plane in world coordinates
  | height | The height of the plane in world coordinates
  | bow | The amount of 'bow' in the curved plane. (Could also be considered the depth.)
  | xsegments | The number of segments to the plane in the x direction
  | ysegments | The number of segments to the plane in the y direction
  | normals | If true, normals are created perpendicular to the plane
  | numTexCoordSets | The number of 2D texture coordinate sets created - by default the corners are created to be the corner of the texture.
  | uTile | The number of times the texture should be repeated in the u direction
  | vTile | The number of times the texture should be repeated in the v direction
  | upVector | The 'Up' direction of the plane.
  | vertexBufferUsage | The usage flag with which the vertex buffer for this plane will be created
  | indexBufferUsage | The usage flag with which the index buffer for this plane will be created
  | vertexShadowBuffer | If this flag is set to true, the vertex buffer will be created with a system memory shadow buffer, allowing you to read it back more efficiently than if it is in hardware
  | indexShadowBuffer | If this flag is set to true, the index buffer will be created with a system memory shadow buffer, allowing you to read it back more efficiently than if it is in hardware

PatchMeshPtr Ogre::MeshManager::createBezierPatch | ( | const String & | name,
|  | const String & | groupName,
|  | void * | controlPointBuffer,
|  | VertexDeclaration * | declaration,
|  | size_t | width,
|  | size_t | height,
|  | size_t | uMaxSubdivisionLevel = `PatchSurface::AUTO_LEVEL`,
|  | size_t | vMaxSubdivisionLevel = `PatchSurface::AUTO_LEVEL`,
|  | PatchSurface::VisibleSide | visibleSide = `PatchSurface::VS_FRONT`,
|  | HardwareBuffer::Usage | vbUsage = `HardwareBuffer::HBU_STATIC_WRITE_ONLY`,
|  | HardwareBuffer::Usage | ibUsage = `HardwareBuffer::HBU_DYNAMIC_WRITE_ONLY`,
|  | bool | vbUseShadow = `true`,
|  | bool | ibUseShadow = `true` |
| ) |  |  |

Creates a Bezier patch based on an array of control vertices.

Parameters:

  | name | The name to give the newly created mesh.
  | groupName | The name of the resource group to assign the mesh to
  | controlPointBuffer | A pointer to a buffer containing the vertex data which defines control points of the curves rather than actual vertices. Note that you are expected to provide not just position information, but potentially normals and texture coordinates too. The format of the buffer is defined in the VertexDeclaration parameter
  | declaration | VertexDeclaration describing the contents of the buffer. Note this declaration must _only_ draw on buffer source 0!
  | width | Specifies the width of the patch in control points. Note this parameter must greater than or equal to 3.
  | height | Specifies the height of the patch in control points. Note this parameter must greater than or equal to 3.
  | uMaxSubdivisionLevel,vMaxSubdivisionLevel | If you want to manually set the top level of subdivision, do it here, otherwise let the system decide.
  | visibleSide | Determines which side of the patch (or both) triangles are generated for.
  | vbUsage | Vertex buffer usage flags. Recommend the default since vertex buffer should be static.
  | ibUsage | Index buffer usage flags. Recommend the default since index buffer should be dynamic to change levels but not readable.
  | vbUseShadow | Flag to determine if a shadow buffer is generated for the vertex buffer. See HardwareBuffer for full details.
  | ibUseShadow | Flag to determine if a shadow buffer is generated for the index buffer. See HardwareBuffer for full details.

void Ogre::MeshManager::setPrepareAllMeshesForShadowVolumes | ( | bool | enable | ) |

Tells the mesh manager that all future meshes should prepare themselves for shadow volumes on loading.

bool Ogre::MeshManager::getPrepareAllMeshesForShadowVolumes | ( | void |  | ) |

Retrieves whether all Meshes should prepare themselves for shadow volumes.

static MeshManager& Ogre::MeshManager::getSingleton | ( | void |  | ) | `[static]`

Override standard Singleton retrieval.

Remarks:
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

Reimplemented from Ogre::Singleton< T >.

static MeshManager* Ogre::MeshManager::getSingletonPtr | ( | void |  | ) | `[static]`

Override standard Singleton retrieval.

Remarks:
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

Reimplemented from Ogre::Singleton< T >.

Real Ogre::MeshManager::getBoundsPaddingFactor | ( | void |  | ) |

Gets the factor by which the bounding box of an entity is padded.

Default is 0.01

void Ogre::MeshManager::setBoundsPaddingFactor | ( | Real | paddingFactor | ) |

Sets the factor by which the bounding box of an entity is padded.

void Ogre::MeshManager::setListener | ( | MeshSerializerListener * | listener | ) |

Sets the listener used to control mesh loading through the serializer.

MeshSerializerListener* Ogre::MeshManager::getListener | ( |  | ) |

Gets the listener used to control mesh loading through the serializer.

void Ogre::MeshManager::loadResource | ( | Resource * | res | ) | `[virtual]`

See also:
  ManualResourceLoader::loadResource

Implements Ogre::ManualResourceLoader.

Resource* Ogre::MeshManager::createImpl | ( | const String & | name,
|  | ResourceHandle | handle,
|  | const String & | group,
|  | bool | isManual,
|  | ManualResourceLoader * | loader,
|  | const NameValuePairList * | createParams |
| ) |  |  | `[protected, virtual]`

Create a new resource instance compatible with this manager (no custom parameters are populated at this point).

Remarks:
  Subclasses must override this method and create a subclass of Resource.

Parameters:

  | name | The unique name of the resource
  | group | The name of the resource group to attach this new resource to
  | isManual | Is this resource manually loaded? If so, you should really populate the loader parameter in order that the load process can call the loader back when loading is required.
  | loader | Pointer to a ManualLoader implementation which will be called when the Resource wishes to load (should be supplied if you set isManual to true). You can in fact leave this parameter null if you wish, but the Resource will never be able to reload if anything ever causes it to unload. Therefore provision of a proper ManualLoader instance is strongly recommended.
  | createParams | If any parameters are required to create an instance, they should be supplied here as name / value pairs. These do not need to be set on the instance (handled elsewhere), just used if required to differentiate which concrete class is created.

Implements Ogre::ResourceManager.

void Ogre::MeshManager::tesselate2DMesh | ( | SubMesh * | pSub,
|  | int | meshWidth,
|  | int | meshHeight,
|  | bool | doubleSided = `false`,
|  | HardwareBuffer::Usage | indexBufferUsage = `HardwareBuffer::HBU_STATIC_WRITE_ONLY`,
|  | bool | indexSysMem = `false` |
| ) |  |  | `[protected]`

Utility method for tessellating 2D meshes.

void Ogre::MeshManager::createPrefabPlane | ( | void |  | ) | `[protected]`

void Ogre::MeshManager::createPrefabCube | ( | void |  | ) | `[protected]`

void Ogre::MeshManager::createPrefabSphere | ( | void |  | ) | `[protected]`

void Ogre::MeshManager::loadManualPlane | ( | Mesh * | pMesh,
|  | MeshBuildParams & | params |
| ) |  |  | `[protected]`

Utility method for manual loading a plane.

void Ogre::MeshManager::loadManualCurvedPlane | ( | Mesh * | pMesh,
|  | MeshBuildParams & | params |
| ) |  |  | `[protected]`

Utility method for manual loading a curved plane.

void Ogre::MeshManager::loadManualCurvedIllusionPlane | ( | Mesh * | pMesh,
|  | MeshBuildParams & | params |
| ) |  |  | `[protected]`

Utility method for manual loading a curved illusion plane.

virtual ResourcePtr Ogre::ResourceManager::create | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0`,
|  | const NameValuePairList * | createParams = `0` |
| ) |  |  | `[virtual, inherited]`

Creates a new blank resource, but does not immediately load it.

Remarks:
  Resource managers handle disparate types of resources, so if you want to get at the detailed interface of this resource, you'll have to cast the result to the subclass you know you're creating.

Parameters:

  | name | The unique name of the resource
  | group | The name of the resource group to attach this new resource to
  | isManual | Is this resource manually loaded? If so, you should really populate the loader parameter in order that the load process can call the loader back when loading is required.
  | loader | Pointer to a ManualLoader implementation which will be called when the Resource wishes to load (should be supplied if you set isManual to true). You can in fact leave this parameter null if you wish, but the Resource will never be able to reload if anything ever causes it to unload. Therefore provision of a proper ManualLoader instance is strongly recommended.
  | createParams | If any parameters are required to create an instance, they should be supplied here as name / value pairs

virtual ResourceCreateOrRetrieveResult Ogre::ResourceManager::createOrRetrieve | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0`,
|  | const NameValuePairList * | createParams = `0` |
| ) |  |  | `[virtual, inherited]`

Create a new resource, or retrieve an existing one with the same name if it already exists.

Remarks:
  This method performs the same task as calling getByName() followed by create() if that returns null. The advantage is that it does it in one call so there are no race conditions if using multiple threads that could cause getByName() to return null, but create() to fail because another thread created a resource in between.

See also:
  ResourceManager::create

  ResourceManager::getByName

Returns:
  A pair, the first element being the pointer, and the second being an indicator specifying whether the resource was newly created.

virtual void Ogre::ResourceManager::setMemoryBudget | ( | size_t | bytes | ) | `[virtual, inherited]`

Set a limit on the amount of memory this resource handler may use.

Remarks:
  If, when asked to load a new resource, the manager believes it will exceed this memory budget, it will temporarily unload a resource to make room for the new one. This unloading is not permanent and the Resource is not destroyed; it simply needs to be reloaded when next used.

virtual size_t Ogre::ResourceManager::getMemoryBudget | ( | void |  | ) | const`[virtual, inherited]`

Get the limit on the amount of memory this resource handler may use.

virtual size_t Ogre::ResourceManager::getMemoryUsage | ( | void |  | ) | const`[virtual, inherited]`

Gets the current memory usage, in bytes.

Definition at line 131 of file OgreResourceManager.h.

virtual void Ogre::ResourceManager::unload | ( | const String & | name | ) | `[virtual, inherited]`

Unloads a single resource by name.

Remarks:
  Unloaded resources are not removed, they simply free up their memory as much as they can and wait to be reloaded.

See also:
  ResourceGroupManager for unloading of resource groups.

virtual void Ogre::ResourceManager::unload | ( | ResourceHandle | handle | ) | `[virtual, inherited]`

Unloads a single resource by handle.

Remarks:
  Unloaded resources are not removed, they simply free up their memory as much as they can and wait to be reloaded.

See also:
  ResourceGroupManager for unloading of resource groups.

virtual void Ogre::ResourceManager::unloadAll | ( | bool | reloadableOnly = `true` | ) | `[virtual, inherited]`

Unloads all resources.

Remarks:
  Unloaded resources are not removed, they simply free up their memory as much as they can and wait to be reloaded.

See also:
  ResourceGroupManager for unloading of resource groups.

Parameters:

  | reloadableOnly | If true (the default), only unload the resource that is reloadable. Because some resources isn't reloadable, they will be unloaded but can't load them later. Thus, you might not want to them unloaded. Or, you might unload all of them, and then populate them manually later.

See also:
  Resource::isReloadable for resource is reloadable.

virtual void Ogre::ResourceManager::reloadAll | ( | bool | reloadableOnly = `true` | ) | `[virtual, inherited]`

Caused all currently loaded resources to be reloaded.

Remarks:
  All resources currently being held in this manager which are also marked as currently loaded will be unloaded, then loaded again.

Parameters:

  | reloadableOnly | If true (the default), only reload the resource that is reloadable. Because some resources isn't reloadable, they will be unloaded but can't loaded again. Thus, you might not want to them unloaded. Or, you might unload all of them, and then populate them manually later.

See also:
  Resource::isReloadable for resource is reloadable.

virtual void Ogre::ResourceManager::unloadUnreferencedResources | ( | bool | reloadableOnly = `true` | ) | `[virtual, inherited]`

Unload all resources which are not referenced by any other object.

Remarks:
  This method behaves like unloadAll, except that it only unloads resources which are not in use, ie not referenced by other objects. This allows you to free up some memory selectively whilst still keeping the group around (and the resources present, just not using much memory).

  Some referenced resource may exists 'weak' pointer to their sub-components (e.g. Entity held pointer to SubMesh), in this case, unload or reload that resource will cause dangerous pointer access. Use this function instead of unloadAll allows you avoid fail in those situations.

Parameters:

  | reloadableOnly | If true (the default), only unloads resources which can be subsequently automatically reloaded.

virtual void Ogre::ResourceManager::reloadUnreferencedResources | ( | bool | reloadableOnly = `true` | ) | `[virtual, inherited]`

Caused all currently loaded but not referenced by any other object resources to be reloaded.

Remarks:
  This method behaves like reloadAll, except that it only reloads resources which are not in use, i.e. not referenced by other objects.

  Some referenced resource may exists 'weak' pointer to their sub-components (e.g. Entity held pointer to SubMesh), in this case, unload or reload that resource will cause dangerous pointer access. Use this function instead of reloadAll allows you avoid fail in those situations.

Parameters:

  | reloadableOnly | If true (the default), only reloads resources which can be subsequently automatically reloaded.

virtual void Ogre::ResourceManager::remove | ( | ResourcePtr & | r | ) | `[virtual, inherited]`

Remove a single resource.

Remarks:
  Removes a single resource, meaning it will be removed from the list of valid resources in this manager, also causing it to be unloaded.

Note:
  The word 'Destroy' is not used here, since if any other pointers are referring to this resource, it will persist until they have finished with it; however to all intents and purposes it no longer exists and will likely get destroyed imminently.

  If you do have shared pointers to resources hanging around after the ResourceManager is destroyed, you may get problems on destruction of these resources if they were relying on the manager (especially if it is a plugin). If you find you get problems on shutdown in the destruction of resources, try making sure you release all your shared pointers before you shutdown OGRE.

virtual void Ogre::ResourceManager::remove | ( | const String & | name | ) | `[virtual, inherited]`

Remove a single resource by name.

Remarks:
  Removes a single resource, meaning it will be removed from the list of valid resources in this manager, also causing it to be unloaded.

Note:
  The word 'Destroy' is not used here, since if any other pointers are referring to this resource, it will persist until they have finished with it; however to all intents and purposes it no longer exists and will likely get destroyed imminently.

  If you do have shared pointers to resources hanging around after the ResourceManager is destroyed, you may get problems on destruction of these resources if they were relying on the manager (especially if it is a plugin). If you find you get problems on shutdown in the destruction of resources, try making sure you release all your shared pointers before you shutdown OGRE.

virtual void Ogre::ResourceManager::remove | ( | ResourceHandle | handle | ) | `[virtual, inherited]`

Remove a single resource by handle.

Remarks:
  Removes a single resource, meaning it will be removed from the list of valid resources in this manager, also causing it to be unloaded.

Note:
  The word 'Destroy' is not used here, since if any other pointers are referring to this resource, it will persist until they have finished with it; however to all intents and purposes it no longer exists and will likely get destroyed imminently.

  If you do have shared pointers to resources hanging around after the ResourceManager is destroyed, you may get problems on destruction of these resources if they were relying on the manager (especially if it is a plugin). If you find you get problems on shutdown in the destruction of resources, try making sure you release all your shared pointers before you shutdown OGRE.

virtual void Ogre::ResourceManager::removeAll | ( | void |  | ) | `[virtual, inherited]`

Removes all resources.

Note:
  The word 'Destroy' is not used here, since if any other pointers are referring to these resources, they will persist until they have been finished with; however to all intents and purposes the resources no longer exist and will get destroyed imminently.

  If you do have shared pointers to resources hanging around after the ResourceManager is destroyed, you may get problems on destruction of these resources if they were relying on the manager (especially if it is a plugin). If you find you get problems on shutdown in the destruction of resources, try making sure you release all your shared pointers before you shutdown OGRE.

Reimplemented in Ogre::CompositorManager.

virtual ResourcePtr Ogre::ResourceManager::getByName | ( | const String & | name | ) | `[virtual, inherited]`

Retrieves a pointer to a resource by name, or null if the resource does not exist.

virtual ResourcePtr Ogre::ResourceManager::getByHandle | ( | ResourceHandle | handle | ) | `[virtual, inherited]`

Retrieves a pointer to a resource by handle, or null if the resource does not exist.

virtual bool Ogre::ResourceManager::resourceExists | ( | const String & | name | ) | `[virtual, inherited]`

Returns whether the named resource exists in this manager.

Definition at line 287 of file OgreResourceManager.h.

virtual bool Ogre::ResourceManager::resourceExists | ( | ResourceHandle | handle | ) | `[virtual, inherited]`

Returns whether a resource with the given handle exists in this manager.

Definition at line 292 of file OgreResourceManager.h.

virtual void Ogre::ResourceManager::_notifyResourceTouched | ( | Resource * | res | ) | `[virtual, inherited]`

Notify this manager that a resource which it manages has been 'touched', i.e.

used.

virtual void Ogre::ResourceManager::_notifyResourceLoaded | ( | Resource * | res | ) | `[virtual, inherited]`

Notify this manager that a resource which it manages has been loaded.

virtual void Ogre::ResourceManager::_notifyResourceUnloaded | ( | Resource * | res | ) | `[virtual, inherited]`

Notify this manager that a resource which it manages has been unloaded.

virtual ResourcePtr Ogre::ResourceManager::prepare | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0`,
|  | const NameValuePairList * | loadParams = `0` |
| ) |  |  | `[virtual, inherited]`

Generic prepare method, used to create a Resource specific to this ResourceManager without using one of the specialised 'prepare' methods (containing per-Resource-type parameters).

Parameters:

  | name | The name of the Resource
  | group | The resource group to which this resource will belong
  | isManual | Is the resource to be manually loaded? If so, you should provide a value for the loader parameter
  | loader | The manual loader which is to perform the required actions when this resource is loaded; only applicable when you specify true for the previous parameter
  | loadParams | Optional pointer to a list of name/value pairs containing loading parameters for this type of resource.

virtual ResourcePtr Ogre::ResourceManager::load | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0`,
|  | const NameValuePairList * | loadParams = `0` |
| ) |  |  | `[virtual, inherited]`

Generic load method, used to create a Resource specific to this ResourceManager without using one of the specialised 'load' methods (containing per-Resource-type parameters).

Parameters:

  | name | The name of the Resource
  | group | The resource group to which this resource will belong
  | isManual | Is the resource to be manually loaded? If so, you should provide a value for the loader parameter
  | loader | The manual loader which is to perform the required actions when this resource is loaded; only applicable when you specify true for the previous parameter
  | loadParams | Optional pointer to a list of name/value pairs containing loading parameters for this type of resource.

virtual const StringVector& Ogre::ResourceManager::getScriptPatterns | ( | void |  | ) | const`[virtual, inherited]`

Gets the file patterns which should be used to find scripts for this ResourceManager.

Remarks:
  Some resource managers can read script files in order to define resources ahead of time. These resources are added to the available list inside the manager, but none are loaded initially. This allows you to load the items that are used on demand, or to load them all as a group if you wish (through ResourceGroupManager).

  This method lets you determine the file pattern which will be used to identify scripts intended for this manager.

Returns:
  A list of file patterns, in the order they should be searched in.

See also:
  isScriptingSupported, parseScript

Implements Ogre::ScriptLoader.

Definition at line 361 of file OgreResourceManager.h.

virtual void Ogre::ResourceManager::parseScript | ( | DataStreamPtr & | stream,
|  | const String & | groupName |
| ) |  |  | `[virtual, inherited]`

Parse the definition of a set of resources from a script file.

Remarks:
  Some resource managers can read script files in order to define resources ahead of time. These resources are added to the available list inside the manager, but none are loaded initially. This allows you to load the items that are used on demand, or to load them all as a group if you wish (through ResourceGroupManager).

Parameters:

  | stream | Weak reference to a data stream which is the source of the script
  | groupName | The name of the resource group that resources which are parsed are to become a member of. If this group is loaded or unloaded, then the resources discovered in this script will be loaded / unloaded with it.

Implements Ogre::ScriptLoader.

Reimplemented in Ogre::CompositorManager, Ogre::FontManager, and Ogre::MaterialManager.

Definition at line 376 of file OgreResourceManager.h.

virtual Real Ogre::ResourceManager::getLoadingOrder | ( | void |  | ) | const`[virtual, inherited]`

Gets the relative loading order of resources of this type.

Remarks:
  There are dependencies between some kinds of resource in terms of loading order, and this value enumerates that. Higher values load later during bulk loading tasks.

Implements Ogre::ScriptLoader.

Definition at line 384 of file OgreResourceManager.h.

const String& Ogre::ResourceManager::getResourceType | ( | void |  | ) | const`[inherited]`

Gets a string identifying the type of resource this manager handles.

Definition at line 387 of file OgreResourceManager.h.

virtual void Ogre::ResourceManager::setVerbose | ( | bool | v | ) | `[virtual, inherited]`

Sets whether this manager and its resources habitually produce log output.

Definition at line 390 of file OgreResourceManager.h.

virtual bool Ogre::ResourceManager::getVerbose | ( | void |  | ) | `[virtual, inherited]`

Gets whether this manager and its resources habitually produce log output.

Definition at line 393 of file OgreResourceManager.h.

ResourceHandle Ogre::ResourceManager::getNextHandle | ( | void |  | ) | `[protected, inherited]`

Allocates the next handle.

virtual void Ogre::ResourceManager::addImpl | ( | ResourcePtr & | res | ) | `[protected, virtual, inherited]`

Add a newly created resource to the manager (note weak reference).

virtual void Ogre::ResourceManager::removeImpl | ( | ResourcePtr & | res | ) | `[protected, virtual, inherited]`

Remove a resource from this manager; remove it from the lists.

virtual void Ogre::ResourceManager::checkUsage | ( | void |  | ) | `[protected, virtual, inherited]`

Checks memory usage and pages out if required.

ResourceMapIterator Ogre::ResourceManager::getResourceIterator | ( | void |  | ) | `[inherited]`

Returns an iterator over all resources in this manager.

Note:
  Use of this iterator is NOT thread safe!

Definition at line 460 of file OgreResourceManager.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 62 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 73 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 79 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 84 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 89 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 106 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

virtual void Ogre::ManualResourceLoader::prepareResource | ( | Resource * | resource | ) | `[virtual, inherited]`

Called when a resource wishes to load.

Note that this could get called in a background thread even in just a semithreaded ogre (OGRE_THREAD_SUPPORT==2). Thus, you must not access the rendersystem from this callback. Do that stuff in loadResource.

Parameters:

  | resource | The resource which wishes to load

Definition at line 501 of file OgreResource.h.

## Member Data Documentation

MeshBuildParamsMap Ogre::MeshManager::mMeshBuildParams`[protected]`

Definition at line 469 of file OgreMeshManager.h.

bool Ogre::MeshManager::mPrepAllMeshesForShadowVolumes`[protected]`

Definition at line 478 of file OgreMeshManager.h.

Real Ogre::MeshManager::mBoundsPaddingFactor`[protected]`

Definition at line 481 of file OgreMeshManager.h.

MeshSerializerListener* Ogre::MeshManager::mListener`[protected]`

Definition at line 484 of file OgreMeshManager.h.

ResourceHandleMap Ogre::ResourceManager::mResourcesByHandle`[protected, inherited]`

Definition at line 437 of file OgreResourceManager.h.

ResourceMap Ogre::ResourceManager::mResources`[protected, inherited]`

Definition at line 438 of file OgreResourceManager.h.

ResourceHandle Ogre::ResourceManager::mNextHandle`[protected, inherited]`

Definition at line 439 of file OgreResourceManager.h.

size_t Ogre::ResourceManager::mMemoryBudget`[protected, inherited]`

Definition at line 440 of file OgreResourceManager.h.

size_t Ogre::ResourceManager::mMemoryUsage`[protected, inherited]`

Definition at line 441 of file OgreResourceManager.h.

bool Ogre::ResourceManager::mVerbose`[protected, inherited]`

Definition at line 443 of file OgreResourceManager.h.

StringVector Ogre::ResourceManager::mScriptPatterns`[protected, inherited]`

Patterns to use to look for scripts if supported (e.g. *.overlay).

Definition at line 448 of file OgreResourceManager.h.

Real Ogre::ResourceManager::mLoadOrder`[protected, inherited]`

Loading order relative to other managers, higher is later.

Definition at line 450 of file OgreResourceManager.h.

String Ogre::ResourceManager::mResourceType`[protected, inherited]`

String identifying the resource type this manager handles.

Definition at line 452 of file OgreResourceManager.h.

template<typename T>

T* Ogre::Singleton< T >::ms_Singleton`[static, protected, inherited]`

Definition at line 61 of file OgreSingleton.h.

Referenced by Ogre::Singleton< Ogre::FontManager >::getSingleton(), Ogre::Singleton< Ogre::FontManager >::getSingletonPtr(), Ogre::Singleton< Ogre::FontManager >::Singleton(), and Ogre::Singleton< Ogre::FontManager >::~Singleton().

The documentation for this class was generated from the following file:

- OgreMeshManager.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Sun Jul 26 11:34:08 2009